{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R+,S-,T-,U-,V+,W-,X+,Y-,Z1}
unit SmilesU;

interface


procedure AddSmiles(Smiles, Subst: string);
  //   
function ReplaceSmiles(S: string): string;
  //     
procedure LoadSmileFile(const FileName: string);


implementation

uses
  SysUtils, Classes;


var
  SmileList: TStringList;


function GetNextWord(var Src: string): string;
var
  P: Integer;
begin
  Src := Trim(Src);
  P := Pos(' ', Src);
  if (P = 0) then P := Length(Src) + 1;
  Result := Copy(Src, 1, P - 1);
  Delete(Src, 1, P);
  Src := Trim(Src);
end;

procedure AddSmiles(Smiles, Subst: string);
var
  Sm: string;
  F: Integer;
begin
  repeat
    Sm := GetNextWord(Smiles);
    if (Sm = '') then break;
    F := 0;
    while (F < SmileList.Count) and (Length(SmileList[F]) >= Length(Sm)) do Inc(F, 2);
    if (F >= SmileList.Count) then
    begin
      SmileList.Append(Sm);
      SmileList.Append(Subst);
    end
    else
    begin
      SmileList.Insert(F, Subst);
      SmileList.Insert(F, Sm);
    end;
  until False;
end;

function ReplaceSmiles(S: string): string;
var
  F, C: Integer;
begin
  Result := S;
  F := 1;
  while (F <= Length(Result)) do
  begin
    C := 0;
    while (C < SmileList.Count - 1) do
    begin
      if (Copy(Result, F, Length(SmileList[C])) = SmileList[C]) then
      begin
        Delete(Result, F, Length(SmileList[C]));
        Insert(SmileList[C+1], Result, F);
        Inc(F, Length(SmileList[C+1]) - 1);
        break;
      end;
      Inc(C, 2);
    end;
    Inc(F);
  end;
end;

procedure LoadSmileFile(const FileName: string);
var
  SL: TStringList;
begin
  SmileList.Clear;
  SL := TStringList.Create;
  try
    try
      SL.LoadFromFile(FileName);
    except exit;
    end;
    while (SL.Count > 1) do
    begin
      AddSmiles(SL[0], SL[1]);
      SL.Delete(0);
      SL.Delete(0);
    end;
  finally
    SL.Free;
  end;
end;


initialization
  SmileList := TStringList.Create;
finalization
  SmileList.Free;
end.
